package tcp

import (
	"io"
	"net"
	"time"

	"git.loafle.net/commons_go/server"
)

type ClientHandlers struct {
	server.ClientHandlers
}

func (ch *ClientHandlers) Dial() (conn io.ReadWriteCloser, err error) {
	dialer := &net.Dialer{
		Timeout:   ch.RequestTimeout * time.Second,
		KeepAlive: ch.KeepAlivePeriod * time.Second,
	}

	return dialer.Dial("tcp", ch.Addr)
}
